# 【修改中】127.0.0.1已完成，外网未测试

## tcp传输

#### 使用说明

**1、接收文件的一端,**需打开文件**tcprecv.py**修改参数

``` python
ip='127.0.0.1'            #目标主机IP
dst='recv'                #文件存放地点，会把.moves文件送进去
tempdir='recvTempFile'    #临时文件
port=43215				  #随意指定的端口号，没有冲突就不管

maxthread=5            #最大开启的线程数量
sleeptime=3  			#请求文件的最少间隔，因为同一时刻有多个线程大家会一起变慢

alpha=0.8          #尝试用滑动平均法来控制sleeptime,网络慢的时候就发慢些
				   #alpha是上一时刻sleeptime的权重
```

**2、发送文件的一端**,需打开**tcpsend.py**文件修改参数，必须要改的是IP

​		

``` python
port=43215             #随意指定的端口号，没有冲突就不管
source='selfplay_data' #存放有.moves和.moves.finish的地方
packsize=64      	#打包时多少个文件一组，小批次的话文件到达得就均匀些，文件产生慢的话似乎也没必要


tempdir='sendTempFile' #临时位置
waitinglist=[]                #这个是还未发送的文件队列，接收到请求时，取出一个进入发送文件的线程
maxExistTempFile=25	 #专门有线程负责打包文件，这个是最大打包文件个数，如果打包速度跟不上传输速度，就可能需要把这个数稍微调大

```



**3、（在有.moves和.moves.finish的，而且有公网IP的服务器上）开启发送端**


```bash
python tcpsend.py
```

会首先检测有多少种前缀，比如测试的15616个文件里有**1087种前缀**

**一定要等到前缀数量和期望的卡的数量相同时再输入y启动**，随便输入点什么可以重新检测

运行起来就只用下标递增了，没办法再检测

想停下来输入quit或exit可以退出



**4、（在没有外网那台服务器）开启接受端**


```
python tcprecv.py
```

需要输入y确认启动，（不启动就ctrl-c），运行中输入quit或exit可以退出





#### 实现

还没写



#### 问题

1、两个包发送间隔用什么参数来估计？现在的公式是
$$
T_{sleep}=\alpha*T_{sleep}+(1-\alpha)T_{trans}*C
$$
​	T_trans是开始连接到传输完成的单次时延，C是一个常数，这个常数目前是1.375，低了会出现拥挤

​	网络波动大的时候情况还没测试，因为只测试过127.0.0.1的情况

​	也许排队论有一些确定方法



2、变成请求文件的模式多了一些步骤，可能还有没考虑的情况