import os
import socket
import threading
import time

ip='120.236.247.203'
dst='recv'
tempdir='recvTempFile'
port=43215

maxthread=5 
sleeptime=1  
alpha=0.8 

delete_command='rm'+' '  #'del ' for windows, 'rm ' for linux
rbuf=512*1024

if not os.path.exists(dst):
    os.system('mkdir '+dst)
    print('[info] create dir:'+dst)
if not os.path.exists(tempdir):
    os.system('mkdir '+tempdir)
    print('[info] create dir:'+tempdir)

def unzip(packname):
    comm='tar -xf '+os.path.join(tempdir,packname)+' -C '+dst
    os.system(comm)
    comm=delete_command+os.path.join(tempdir,packname)
    os.system(comm)

def requestThread():
    global sleeptime
    while True:
        time_start=time.time()
        try:
            sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
            sock.setsockopt(socket.SOL_SOCKET,socket.SO_RCVBUF,rbuf)
            sock.connect((ip, port))
            data = sock.recv(50)
            filename = data.decode()
            if filename=='wait':
                sleeptime=5
                break
            
            sock.sendall('ACK'.encode())
            with open(os.path.join(tempdir,filename), 'wb') as F:
                part = sock.recv(65536)
                while part:
                    F.write(part)
                    part = sock.recv(65536)

        except Exception as e:
            print(e)
            print('request failed...retry')
        else:
            #sock.close()
            time_end=time.time()
            print('request '+filename+'...done!total time={:.3f} sec,sleep time={:.3f} sec'.format(time_end-time_start,sleeptime))
            sleeptime=min(5,alpha*sleeptime+(1-alpha)*(time_end-time_start)*1.375)

            unzip(filename)
            break

runMainLoop=True
def listenforkeyboard():
    while True:
        aaa=input('[info] input <quit/exit> can quit:\n')
        print('you input:'+aaa)
        if aaa=='quit' or aaa=='exit':
            global runMainLoop
            runMainLoop=False
            break

a=''
while not (a=='Y' or a=='y'):
    a=input('start receiving?<Y or y> :')

t = threading.Thread(target=listenforkeyboard)
t.start() 



while runMainLoop:
    if len(threading.enumerate())<maxthread:
        t=threading.Thread(target=requestThread)
        t.setDaemon(True)
        t.start()
        time.sleep(sleeptime)



print('[info] stop and exit! will delete temp file (or not)')
print('[info] and all the thread will end (dont know what will happen)')