import os
import socket
import threading
import time

dst='recv'
tempdir='recvTempFile'
port=43215


delete_command='del'+' '  #'del ' for windows, 'rm ' for linux

def handle_file(sock):
    data = b''
    while True:
        part = sock.recv(1024)
        data += part
        if len(part) < 1024:
            break
    filename = data.decode('utf-8')
    sock.sendall('ACK'.encode('utf-8'))
    with open(os.path.join(tempdir,filename), 'wb') as F:
        part = sock.recv(4096)
        while part:
            F.write(part)
            part = sock.recv(4096)
    comm='tar -xf '+os.path.join(tempdir,filename)+' -C '+dst
    os.system(comm)
    comm=delete_command+os.path.join(tempdir,filename)
    os.system(comm)
    print(filename+'...received!')



if not os.path.exists(dst):
    os.system('mkdir '+dst)
    print('[info] create dir:'+dst)
if not os.path.exists(tempdir):
    os.system('mkdir '+tempdir)
    print('[info] create dir:'+tempdir)

runMainLoop=True
def listenforkeyboard():
    while True:
        aaa=input('[info] input <quit/exit> can quit:\n')
        print('you input:'+aaa)
        if aaa=='quit' or aaa=='exit':
            global runMainLoop
            runMainLoop=False
            break

a=''
while not (a=='Y' or a=='y'):
    a=input('start receiving?<Y or y> :')

t = threading.Thread(target=listenforkeyboard)
t.start() 

server = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
server.bind(('0.0.0.0', port))
server.listen(10)
server.settimeout(1)

while runMainLoop:
    try:        
        sock, _ = server.accept()
    except:
        pass
    else:
        n=threading.Thread(target=handle_file, args=(sock,))
        n.start()

print('[info] stop and exit! will delete temp file (or not)')
print('[info] and all the thread will end (dont know what will happen)')